%{
typedef struct { int dummy;} geo_t;
#include "tokens.h"
%}

number	(-?[0-9]+)
real	(-?[0-9]+("."[0-9]*)?)
name	([A-Za-z][A-Za-z0-9._-]*)

%%

"#"		{ while (input() != '\n') ; }
delete		{ return DELETE; }
grow		{ return GROW; }
growx		{ return GROWX; }
growy		{ return GROWY; }
squares		{ return SQUARES; }
frame		{ return FRAME; }
framex		{ return FRAMEX; }
framey		{ return FRAMEY; }
scale		{ return SCALE; }
property	{ return PROPERTY; }
options		{ return OPTIONS; }
labels		{ return LABELS; }
bb		{ return BOUNDBOX; }
flatten		{ return FLATTEN; }
subcell		{ return SUBCELL; }

\".*\"		{ int c;
		  yyleng = 0; 
		  while ((c=input()) != '"') yytext[yyleng++] = c;
		  return NAME; 
		}

{name}		{ return NAME; }
{number}	{ return NUMBER; }
{real}		{ return REAL; }

"="		{ return EQUAL; }
"+"		{ return PLUS; }
"-"		{ return MINUS; }
"*"		{ return TIMES; }
"^"		{ return XOR; }
";"		{ return SEMI; }
","		{ return COMMA; }
"("		{ return LPAREN; }
")"		{ return RPAREN; }
"/"		{ return SLASH; }

[ \t\n]		;
.		{ return INVALID; }

%%
